library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;


entity FSMCounter is
   port ( CLR,CLK,UPDOWN,HOLD: in  std_logic;
                          RCO: out std_logic;
                            Y: out std_logic_vector(3 downto 0);
				        Z: out std_logic_vector(1 downto 0));
end FSMCounter;

architecture myFSMCounter of FSMCounter is

--Internal State signal
signal S : std_logic_vector(3 downto 0); 

begin
   process (CLK,UPDOWN,HOLD,CLR)
   begin
      --CLR sets the state to S0
	 if (CLR = '1') then 
	    S <= "0001";
      elsif (rising_edge(CLK)) then
         S(0) <= (S(0) and HOLD) or
	            (S(1) and (not Hold) and not(UPDOWN)) or 
			  (S(3) and UPDOWN and not (HOLD));
         S(1) <= (S(1) and HOLD) or 
	            (S(2) and not(Hold) and not(UPDOWN)) or 
			  (S(0) and not(Hold) and (UPDOWN));
         S(2) <= (S(2) and HOLD) or 
	            (S(2) and not(Hold) and not(UPDOWN)) or 
			  (S(3) and not(Hold) and (UPDOWN));
         S(3) <= (S(3) and HOLD) or 
	            (S(0) and not(Hold) and not(UPDOWN)) or 
			  (S(2) and not(Hold) and (UPDOWN));
      end if;

   end process;
   --Assign internal signal to output     
   Y <= S;

   --Assign Z Outputs.
   Z(0) <= S(1) or S(3);
   Z(1) <= S(2) or S(3);
   
   -- Assign RCO high when state is 3
   RCO <= S(3);  


end myFSMCounter;
