-- \\FORBES.EE.CALPOLY.EDU\FALLSTUHOMEDIR\F269S1B3\LAB2
-- VHDL Test Bench created by
-- HDL Bencher 6.1i
-- Tue Oct 04 10:54:53 2005
-- 
-- Notes:
-- 1) This testbench has been automatically generated from
--   your Test Bench Waveform
-- 2) To use this as a user modifiable testbench do the following:
--   - Save it as a file with a .vhd extension (i.e. File->Save As...)
--   - Add it to your project as a testbench source (i.e. Project->Add Source...)
-- 

LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;
USE IEEE.STD_LOGIC_TEXTIO.ALL;
USE STD.TEXTIO.ALL;

ENTITY Test IS
END Test;

ARCHITECTURE testbench_arch OF Test IS
-- If you get a compiler error on the following line,
-- from the menu do Options->Configuration select VHDL 87
FILE RESULTS: TEXT OPEN WRITE_MODE IS "results.txt";
	COMPONENT fsmcounter
		PORT (
			CLR : In  std_logic;
			CLK : In  std_logic;
			UPDOWN : In  std_logic;
			HOLD : In  std_logic;
			RCO : Out  std_logic;
			Y : Out  std_logic_vector (3 DOWNTO 0);
			Z : Out  std_logic_vector (1 DOWNTO 0)
		);
	END COMPONENT;

	SIGNAL CLR : std_logic;
	SIGNAL CLK : std_logic;
	SIGNAL UPDOWN : std_logic;
	SIGNAL HOLD : std_logic;
	SIGNAL RCO : std_logic;
	SIGNAL Y : std_logic_vector (3 DOWNTO 0);
	SIGNAL Z : std_logic_vector (1 DOWNTO 0);

BEGIN
	UUT : fsmcounter
	PORT MAP (
		CLR => CLR,
		CLK => CLK,
		UPDOWN => UPDOWN,
		HOLD => HOLD,
		RCO => RCO,
		Y => Y,
		Z => Z
	);

	PROCESS -- clock process for CLK,
	BEGIN
		CLOCK_LOOP : LOOP
		CLK <= transport '0';
		WAIT FOR 10 ns;
		CLK <= transport '1';
		WAIT FOR 10 ns;
		WAIT FOR 40 ns;
		CLK <= transport '0';
		WAIT FOR 40 ns;
		END LOOP CLOCK_LOOP;
	END PROCESS;

	PROCESS   -- Process for CLK
		VARIABLE TX_OUT : LINE;
		VARIABLE TX_ERROR : INTEGER := 0;

		PROCEDURE CHECK_RCO(
			next_RCO : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (RCO /= next_RCO) THEN 
				STD.TEXTIO.write(TX_LOC,string'("Error at time="));
				STD.TEXTIO.write(TX_LOC, TX_TIME);
				STD.TEXTIO.write(TX_LOC,string'("ns RCO="));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, RCO);
				STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_RCO);
				STD.TEXTIO.write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				STD.TEXTIO.writeline(results, TX_LOC);
				STD.TEXTIO.Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_Y(
			next_Y : std_logic_vector (3 DOWNTO 0);
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (Y /= next_Y) THEN 
				STD.TEXTIO.write(TX_LOC,string'("Error at time="));
				STD.TEXTIO.write(TX_LOC, TX_TIME);
				STD.TEXTIO.write(TX_LOC,string'("ns Y="));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, Y);
				STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_Y);
				STD.TEXTIO.write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				STD.TEXTIO.writeline(results, TX_LOC);
				STD.TEXTIO.Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_Z(
			next_Z : std_logic_vector (1 DOWNTO 0);
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (Z /= next_Z) THEN 
				STD.TEXTIO.write(TX_LOC,string'("Error at time="));
				STD.TEXTIO.write(TX_LOC, TX_TIME);
				STD.TEXTIO.write(TX_LOC,string'("ns Z="));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, Z);
				STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_Z);
				STD.TEXTIO.write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				STD.TEXTIO.writeline(results, TX_LOC);
				STD.TEXTIO.Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		BEGIN
		-- --------------------
		UPDOWN <= transport '1';
		HOLD <= transport '0';
		CLR <= transport '1';
		-- --------------------
		WAIT FOR 100 ns; -- Time=100 ns
		CLR <= transport '0';
		-- --------------------
		WAIT FOR 100 ns; -- Time=200 ns
		HOLD <= transport '1';
		-- --------------------
		WAIT FOR 100 ns; -- Time=300 ns
		HOLD <= transport '0';
		-- --------------------
		WAIT FOR 300 ns; -- Time=600 ns
		HOLD <= transport '1';
		-- --------------------
		WAIT FOR 100 ns; -- Time=700 ns
		HOLD <= transport '0';
		CLR <= transport '1';
		-- --------------------
		WAIT FOR 100 ns; -- Time=800 ns
		UPDOWN <= transport '0';
		CLR <= transport '0';
		-- --------------------
		WAIT FOR 200 ns; -- Time=1000 ns
		HOLD <= transport '1';
		-- --------------------
		WAIT FOR 200 ns; -- Time=1200 ns
		HOLD <= transport '0';
		-- --------------------
		WAIT FOR 210 ns; -- Time=1410 ns
		-- --------------------

		IF (TX_ERROR = 0) THEN 
			STD.TEXTIO.write(TX_OUT,string'("No errors or warnings"));
			STD.TEXTIO.writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Simulation successful (not a failure).  No problems detected. "
				SEVERITY FAILURE;
		ELSE
			STD.TEXTIO.write(TX_OUT, TX_ERROR);
			STD.TEXTIO.write(TX_OUT, string'(
				" errors found in simulation"));
			STD.TEXTIO.writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Errors found during simulation"
				SEVERITY FAILURE;
		END IF;
	END PROCESS;
END testbench_arch;

CONFIGURATION fsmcounter_cfg OF Test IS
	FOR testbench_arch
	END FOR;
END fsmcounter_cfg;
